commit b3881e820e87ccaabfb2c4a08d3cd07974c59b75
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Wed Dec 24 13:48:55 2025 +0000

    Move lookup options & variables from global to module

diff --git a/src/src/drtables.c b/src/src/drtables.c
index ec9ca3c67..20034e7ce 100644
--- a/src/src/drtables.c
+++ b/src/src/drtables.c
@@ -152,7 +152,7 @@ return dl;
 /* Try to load a lookup module with the given name.
 
 Arguments:
-    name		name of the lookup
+    name		name of the module
     errstr		if not NULL, place "open fail" error message here
 
 Return: boolean success
@@ -211,6 +211,15 @@ return TRUE;
 
 #endif	/*LOOKUP_MODULE_DIR*/
 
+const lookup_info *
+lookup_find(const uschar * name, uschar ** errstr)
+{
+const lookup_info * li;
+if ((li = lookup_findonly(name))) return li;
+lookup_mod_load(name, errstr);
+return lookup_findonly(name);
+}
+
 /* Look at all the lookup module files and add a name from each lookup type */
 
 gstring *
diff --git a/src/src/expand.c b/src/src/expand.c
index 85d27b534..ab0c0b37a 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -459,10 +459,10 @@ static var_entry var_table[] = {
   { "address_file",        vtype_stringptr,   &address_file },
   { "address_pipe",        vtype_stringptr,   &address_pipe },
 #ifdef EXPERIMENTAL_ARC
-  { "arc_domains",         vtype_module,	US"arc" },
-  { "arc_oldest_pass",     vtype_module,	US"arc" },
-  { "arc_state",           vtype_module,	US"arc" },
-  { "arc_state_reason",    vtype_module,	US"arc" },
+  { "arc_domains",         vtype_misc_module,	US"arc" },
+  { "arc_oldest_pass",     vtype_misc_module,	US"arc" },
+  { "arc_state",           vtype_misc_module,	US"arc" },
+  { "arc_state_reason",    vtype_misc_module,	US"arc" },
 #endif
   { "atrn_host",	   vtype_stringptr,   &atrn_host },
   { "atrn_mode",	   vtype_stringptr,   &atrn_mode },
@@ -491,36 +491,36 @@ static var_entry var_table[] = {
   { "dcc_result",          vtype_stringptr,   &dcc_result },
 #endif
 #ifndef DISABLE_DKIM
-  { "dkim_algo",           vtype_module,	US"dkim" },
-  { "dkim_bodylength",     vtype_module,	US"dkim" },
-  { "dkim_canon_body",     vtype_module,	US"dkim" },
-  { "dkim_canon_headers",  vtype_module,	US"dkim" },
-  { "dkim_copiedheaders",  vtype_module,	US"dkim" },
-  { "dkim_created",        vtype_module,	US"dkim" },
-  { "dkim_cur_signer",     vtype_module,	US"dkim" },
-  { "dkim_domain",         vtype_module,	US"dkim" },
-  { "dkim_expires",        vtype_module,	US"dkim" },
-  { "dkim_headernames",    vtype_module,	US"dkim" },
-  { "dkim_identity",       vtype_module,	US"dkim" },
-  { "dkim_key_granularity",vtype_module,	US"dkim" },
-  { "dkim_key_length",     vtype_module,	US"dkim" },
-  { "dkim_key_nosubdomains",vtype_module,	US"dkim" },
-  { "dkim_key_notes",      vtype_module,	US"dkim" },
-  { "dkim_key_srvtype",    vtype_module,	US"dkim" },
-  { "dkim_key_testing",    vtype_module,	US"dkim" },
-  { "dkim_selector",       vtype_module,	US"dkim" },
-  { "dkim_signers",        vtype_module,	US"dkim" },
-  { "dkim_verify_reason",  vtype_module,	US"dkim" },
-  { "dkim_verify_signers", vtype_module,	US"dkim" },
-  { "dkim_verify_status",  vtype_module,	US"dkim" },
+  { "dkim_algo",           vtype_misc_module,	US"dkim" },
+  { "dkim_bodylength",     vtype_misc_module,	US"dkim" },
+  { "dkim_canon_body",     vtype_misc_module,	US"dkim" },
+  { "dkim_canon_headers",  vtype_misc_module,	US"dkim" },
+  { "dkim_copiedheaders",  vtype_misc_module,	US"dkim" },
+  { "dkim_created",        vtype_misc_module,	US"dkim" },
+  { "dkim_cur_signer",     vtype_misc_module,	US"dkim" },
+  { "dkim_domain",         vtype_misc_module,	US"dkim" },
+  { "dkim_expires",        vtype_misc_module,	US"dkim" },
+  { "dkim_headernames",    vtype_misc_module,	US"dkim" },
+  { "dkim_identity",       vtype_misc_module,	US"dkim" },
+  { "dkim_key_granularity",vtype_misc_module,	US"dkim" },
+  { "dkim_key_length",     vtype_misc_module,	US"dkim" },
+  { "dkim_key_nosubdomains",vtype_misc_module,	US"dkim" },
+  { "dkim_key_notes",      vtype_misc_module,	US"dkim" },
+  { "dkim_key_srvtype",    vtype_misc_module,	US"dkim" },
+  { "dkim_key_testing",    vtype_misc_module,	US"dkim" },
+  { "dkim_selector",       vtype_misc_module,	US"dkim" },
+  { "dkim_signers",        vtype_misc_module,	US"dkim" },
+  { "dkim_verify_reason",  vtype_misc_module,	US"dkim" },
+  { "dkim_verify_signers", vtype_misc_module,	US"dkim" },
+  { "dkim_verify_status",  vtype_misc_module,	US"dkim" },
 #endif
 #ifdef EXIM_HAVE_DMARC
-  { "dmarc_alignment_dkim",vtype_module,	US"dmarc" },
-  { "dmarc_alignment_spf", vtype_module,	US"dmarc" },
-  { "dmarc_domain_policy", vtype_module,	US"dmarc" },
-  { "dmarc_status",        vtype_module,	US"dmarc" },
-  { "dmarc_status_text",   vtype_module,	US"dmarc" },
-  { "dmarc_used_domain",   vtype_module,	US"dmarc" },
+  { "dmarc_alignment_dkim",vtype_misc_module,	US"dmarc" },
+  { "dmarc_alignment_spf", vtype_misc_module,	US"dmarc" },
+  { "dmarc_domain_policy", vtype_misc_module,	US"dmarc" },
+  { "dmarc_status",        vtype_misc_module,	US"dmarc" },
+  { "dmarc_status_text",   vtype_misc_module,	US"dmarc" },
+  { "dmarc_used_domain",   vtype_misc_module,	US"dmarc" },
 #endif
   { "dnslist_domain",      vtype_stringptr,   &dnslist_domain },
   { "dnslist_matched",     vtype_stringptr,   &dnslist_matched },
@@ -554,7 +554,7 @@ static var_entry var_table[] = {
   { "interface_port",      vtype_int,         &interface_port },
   { "item",                vtype_stringptr,   &iterate_item },
 #ifdef LOOKUP_LDAP
-  { "ldap_dn",             vtype_stringptr,   &eldap_dn },
+  { "ldap_dn",             vtype_lookup_module, US"ldap" },
 #endif
   { "load_average",        vtype_load_avg,    NULL },
   { "local_part",          vtype_stringptr,   &deliver_localpart },
@@ -713,13 +713,13 @@ static var_entry var_table[] = {
   { "spam_score_int",      vtype_stringptr,   &spam_score_int },
 #endif
 #ifdef EXIM_HAVE_SPF
-  { "spf_guess",           vtype_module,	US"spf" },
-  { "spf_header_comment",  vtype_module,	US"spf" },
-  { "spf_received",        vtype_module,	US"spf" },
-  { "spf_result",          vtype_module,	US"spf" },
-  { "spf_result_guessed",  vtype_module,	US"spf" },
-  { "spf_smtp_comment",    vtype_module,	US"spf" },
-  { "spf_used_domain",	   vtype_module,	US"spf" },
+  { "spf_guess",           vtype_misc_module,	US"spf" },
+  { "spf_header_comment",  vtype_misc_module,	US"spf" },
+  { "spf_received",        vtype_misc_module,	US"spf" },
+  { "spf_result",          vtype_misc_module,	US"spf" },
+  { "spf_result_guessed",  vtype_misc_module,	US"spf" },
+  { "spf_smtp_comment",    vtype_misc_module,	US"spf" },
+  { "spf_used_domain",	   vtype_misc_module,	US"spf" },
 #endif
   { "spool_directory",     vtype_stringptr,   &spool_directory },
   { "spool_inodes",        vtype_pinodes,     (void *)TRUE },
@@ -2161,7 +2161,7 @@ switch (vp->type)
     }
 #endif
 
-  case vtype_module:
+  case vtype_misc_module:
     {
     uschar * errstr;
     misc_module_info * mi = misc_mod_find(val, &errstr);
diff --git a/src/src/functions.h b/src/src/functions.h
index b2c2626ab..57ae06c58 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -307,6 +307,8 @@ extern void    log_write_die(unsigned, int, const char * format, ...)
 
 extern const lookup_info * lookup_with_acq_num(unsigned);
 extern gstring *lookup_dynamic_supported(gstring *);
+extern const lookup_info * lookup_find(const uschar *, uschar **);
+extern const lookup_info * lookup_findonly(const uschar *);
 #ifdef LOOKUP_MODULE_DIR
 extern BOOL    lookup_one_mod_load(const uschar *, uschar **);
 #endif
diff --git a/src/src/globals.c b/src/src/globals.c
index e5de80ea4..4fe89f727 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -58,39 +58,6 @@ BOOL    opt_perl_taintmode     = FALSE;
 tree_node *dlobj_anchor        = NULL;
 #endif
 
-#ifdef LOOKUP_LDAP
-uschar *eldap_ca_cert_dir      = NULL;
-uschar *eldap_ca_cert_file     = NULL;
-uschar *eldap_cert_file        = NULL;
-uschar *eldap_cert_key         = NULL;
-uschar *eldap_cipher_suite     = NULL;
-uschar *eldap_default_servers  = NULL;
-uschar *eldap_require_cert     = NULL;
-int     eldap_version          = -1;
-BOOL    eldap_start_tls        = FALSE;
-#endif
-
-#ifdef LOOKUP_MYSQL
-uschar *mysql_servers          = NULL;
-#endif
-
-#ifdef LOOKUP_ORACLE
-uschar *oracle_servers         = NULL;
-#endif
-
-#ifdef LOOKUP_PGSQL
-uschar *pgsql_servers          = NULL;
-#endif
-
-#ifdef LOOKUP_REDIS
-uschar *redis_servers          = NULL;
-#endif
-
-#ifdef LOOKUP_SQLITE
-uschar *sqlite_dbfile	       = NULL;
-int     sqlite_lock_timeout    = 5;
-#endif
-
 #ifdef SUPPORT_MOVE_FROZEN_MESSAGES
 BOOL    move_frozen_messages   = FALSE;
 #endif
@@ -908,7 +875,6 @@ uschar *keep_environment       = NULL;
 
 int     keep_malformed         = 4*24*60*60;    /* 4 days */
 
-uschar *eldap_dn               = NULL;
 const uschar *letter_digit_hyphen_dot =
     US"abcdefghijklmnopqrstuvwxyz"
       ".-0123456789"
diff --git a/src/src/globals.h b/src/src/globals.h
index 313062890..f8cd0548b 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -40,39 +40,6 @@ extern BOOL    opt_perl_taintmode;     /* Enable taint mode in Perl */
 extern tree_node *dlobj_anchor;        /* Tree of dynamically-loaded objects */
 #endif
 
-#ifdef LOOKUP_LDAP
-extern uschar *eldap_ca_cert_dir;      /* Directory with CA certificates */
-extern uschar *eldap_ca_cert_file;     /* CA certificate file */
-extern uschar *eldap_cert_file;        /* Certificate file */
-extern uschar *eldap_cert_key;         /* Certificate key file */
-extern uschar *eldap_cipher_suite;     /* Allowed cipher suite */
-extern uschar *eldap_default_servers;  /* List of default servers */
-extern uschar *eldap_require_cert;     /* Peer certificate checking strategy */
-extern BOOL    eldap_start_tls;        /* Use STARTTLS */
-extern int     eldap_version;          /* LDAP version */
-#endif
-
-#ifdef LOOKUP_MYSQL
-extern uschar *mysql_servers;          /* List of servers and connect info */
-#endif
-
-#ifdef LOOKUP_ORACLE
-extern uschar *oracle_servers;         /* List of servers and connect info */
-#endif
-
-#ifdef LOOKUP_PGSQL
-extern uschar *pgsql_servers;          /* List of servers and connect info */
-#endif
-
-#ifdef LOOKUP_REDIS
-extern uschar *redis_servers;          /* List of servers and connect info */
-#endif
-
-#ifdef LOOKUP_SQLITE
-extern uschar *sqlite_dbfile;	       /* Filname for database */
-extern int     sqlite_lock_timeout;    /* Internal lock waiting timeout */
-#endif
-
 #ifdef SUPPORT_MOVE_FROZEN_MESSAGES
 extern BOOL    move_frozen_messages;   /* Get them out of the normal directory */
 #endif
@@ -677,7 +644,6 @@ extern int     journal_fd;             /* Fd for journal file */
 extern uschar *keep_environment;       /* Whitelist for environment variables */
 extern int     keep_malformed;         /* Time to keep malformed messages */
 
-extern uschar *eldap_dn;               /* Where LDAP DNs are left */
 extern const uschar *letter_digit_hyphen_dot; /* Legitimate DNS host name chars */
 #ifndef DISABLE_ESMTP_LIMITS
 extern uschar *limits_advertise_hosts; /* for banner/EHLO pipelining */
diff --git a/src/src/lookupapi.h b/src/src/lookupapi.h
index b8ec17880..84f150e03 100644
--- a/src/src/lookupapi.h
+++ b/src/src/lookupapi.h
@@ -50,15 +50,21 @@ typedef struct lookup_info {
     unsigned);			  /* lookup type index */
   gstring * (*version_report)(    /* diagnostic function */
     gstring *);                   /* string to appand to */
+
+  void *	options;
+  unsigned	options_count;
+  void *	variables;
+  unsigned	variables_count;
 } lookup_info;
 
 /* This magic number is used by the following lookup_module_info structure
    for checking API compatibility. It used to be equivalent to the string"LMM3" */
-#define LOOKUP_MODULE_INFO_MAGIC 0x4c4d4935
+#define LOOKUP_MODULE_INFO_MAGIC 0x4c4d4936
 /* Version 2 adds: version_report */
 /* Version 3 change: non/cache becomes TTL in seconds */
 /* Version 4 add: index on quoting function */
 /* Version 5 change: version report now adds to a gstring */
+/* Version 6 add: options */
 
 typedef struct lookup_module_info {
   uint		magic;
diff --git a/src/src/lookups/ldap.c b/src/src/lookups/ldap.c
index 0a00633ab..06b82aa4c 100644
--- a/src/src/lookups/ldap.c
+++ b/src/src/lookups/ldap.c
@@ -74,6 +74,19 @@ LDAP_LIB_OPENLDAP1
 SEARCH_LDAP_DN lookup). */
 
 
+static uschar * eldap_ca_cert_dir      = NULL; /* Directory with CA certificates */
+static uschar * eldap_ca_cert_file     = NULL; /* CA certificate file */
+static uschar * eldap_cert_file        = NULL; /* Certificate file */
+static uschar * eldap_cert_key         = NULL; /* Certificate key file */
+static uschar * eldap_cipher_suite     = NULL; /* Allowed cipher suite */
+static uschar * eldap_default_servers  = NULL; /* List of default servers */
+static uschar * eldap_require_cert     = NULL; /* Peer certificate checking strategy */
+static int      eldap_version          = -1;	/* Use STARTTLS */
+static BOOL     eldap_start_tls        = FALSE; /* LDAP version */
+
+static uschar * eldap_dn;			/* Where LDAP DNs are left */
+
+
 /* Structure and anchor for caching connections. */
 
 typedef struct ldap_connection {
@@ -87,7 +100,7 @@ typedef struct ldap_connection {
   LDAP *ld;
 } LDAP_CONNECTION;
 
-static LDAP_CONNECTION *ldap_connections = NULL;
+static LDAP_CONNECTION * ldap_connections = NULL;
 
 
 
@@ -1587,16 +1600,42 @@ return string_cat(g, "Library version: LDAP: (unknown)\n");
 }
 
 
+/******************************************************************************/
+/* Module API */
+
+static optionlist eldap_options[] = {
+  { "ldap_ca_cert_dir",         opt_stringptr,   {&eldap_ca_cert_dir} },
+  { "ldap_ca_cert_file",        opt_stringptr,   {&eldap_ca_cert_file} },
+  { "ldap_cert_file",           opt_stringptr,   {&eldap_cert_file} },
+  { "ldap_cert_key",            opt_stringptr,   {&eldap_cert_key} },
+  { "ldap_cipher_suite",        opt_stringptr,   {&eldap_cipher_suite} },
+  { "ldap_default_servers",     opt_stringptr,   {&eldap_default_servers} },
+  { "ldap_require_cert",        opt_stringptr,   {&eldap_require_cert} },
+  { "ldap_start_tls",           opt_bool,        {&eldap_start_tls} },
+  { "ldap_version",             opt_int,         {&eldap_version} },
+};
+
+static var_entry eldap_variables[] = {
+  { "ldap_dn",             vtype_stringptr,   &eldap_dn },
+};
+
 static lookup_info ldap_lookup_info = {
-  .name = US"ldap",			/* lookup name */
-  .type = lookup_querystyle,		/* query-style lookup */
-  .open = eldap_open,			/* open function */
-  .check = NULL,			/* check function */
-  .find = eldap_find,			/* find function */
-  .close = NULL,			/* no close function */
-  .tidy = eldap_tidy,			/* tidy function */
-  .quote = eldap_quote,			/* quoting function */
-  .version_report = ldap_version_report	/* version reporting */
+  .name =	US"ldap",			/* lookup name */
+  .type =	lookup_querystyle,		/* query-style lookup */
+  .open =	eldap_open,			/* open function */
+  .check =	NULL,				/* check function */
+  .find =	eldap_find,			/* find function */
+  .close =	NULL,				/* no close function */
+  .tidy =	eldap_tidy,			/* tidy function */
+  .quote =	eldap_quote,			/* quoting function */
+  .version_report = ldap_version_report,	/* version reporting */
+
+  /* This lookup name matches the modules name, so access options here */
+  .options =	eldap_options,
+  .options_count = nelem(eldap_options),
+
+  .variables =	eldap_variables,
+  .variables_count = nelem(eldap_variables),
 };
 
 static lookup_info ldapdn_lookup_info = {
diff --git a/src/src/lookups/mysql.c b/src/src/lookups/mysql.c
index f28e9154f..dca125188 100644
--- a/src/src/lookups/mysql.c
+++ b/src/src/lookups/mysql.c
@@ -64,6 +64,8 @@ with versions before 10.2, as they do not define there there specific symbols.
 #endif
 
 
+static uschar * mysql_servers = NULL;	/* List of servers and connect info */
+
 /* Structure and anchor for caching connections. */
 
 typedef struct mysql_connection {
@@ -478,18 +480,28 @@ g = string_fmt_append(g,
 return g;
 }
 
+/******************************************************************************/
+/* Module API */
+
+static optionlist mysql_glbl_options[] = {
+  { "mysql_servers",	opt_stringptr,	{&mysql_servers} }
+};
+
 /* These are the lookup_info blocks for this driver */
 
 static lookup_info mysql_lookup_info = {
-  .name = US"mysql",			/* lookup name */
-  .type = lookup_querystyle,		/* query-style lookup */
-  .open = mysql_open,			/* open function */
-  .check = NULL,			/* no check function */
-  .find = mysql_find,			/* find function */
-  .close = NULL,			/* no close function */
-  .tidy = mysql_tidy,			/* tidy function */
-  .quote = mysql_quote,			/* quoting function */
-  .version_report = mysql_version_report           /* version reporting */
+  .name =	US"mysql",			/* lookup name */
+  .type =	lookup_querystyle,		/* query-style lookup */
+  .open =	mysql_open,			/* open function */
+  .check =	NULL,				/* no check function */
+  .find =	mysql_find,			/* find function */
+  .close =	NULL,				/* no close function */
+  .tidy =	mysql_tidy,			/* tidy function */
+  .quote =	mysql_quote,			/* quoting function */
+  .version_report = mysql_version_report,	/* version reporting */
+
+  .options =	mysql_glbl_options,
+  .options_count = nelem(mysql_glbl_options),
 };
 
 #ifdef DYNLOOKUP
diff --git a/src/src/lookups/oracle.c b/src/src/lookups/oracle.c
index e4eedbe28..9472fc2ff 100644
--- a/src/src/lookups/oracle.c
+++ b/src/src/lookups/oracle.c
@@ -69,6 +69,11 @@ typedef struct Ora_Define {
   ub2   col_retlen, col_retcode;
 } Ora_Define;
 
+
+
+static uschar * oracle_servers = NULL;	/* List of servers and connect info */
+
+
 /* Structure and anchor for caching connections. */
 
 typedef struct oracle_connection {
@@ -604,16 +609,26 @@ return g;
 }
 
 
+/******************************************************************************/
+/* Module API */
+
+static optionlist oracle_options[] = {
+  { "oracle_servers",	opt_stringptr,	{&oracle_servers} }
+};
+
 static lookup_info _lookup_info = {
-  .name = US"oracle",			/* lookup name */
-  .type = lookup_querystyle,		/* query-style lookup */
-  .open = oracle_open,			/* open function */
-  .check = NULL,			/* check function */
-  .find = oracle_find,			/* find function */
-  .close = NULL,			/* no close function */
-  .tidy = oracle_tidy,			/* tidy function */
-  .quote = oracle_quote,		/* quoting function */
-  .version_report = oracle_version_report          /* version reporting */
+  .name =	US"oracle",			/* lookup name */
+  .type =	lookup_querystyle,		/* query-style lookup */
+  .open =	oracle_open,			/* open function */
+  .check =	NULL,				/* check function */
+  .find =	oracle_find,			/* find function */
+  .close =	NULL,				/* no close function */
+  .tidy =	oracle_tidy,			/* tidy function */
+  .quote =	oracle_quote,			/* quoting function */
+  .version_report = oracle_version_report,	/* version reporting */
+
+  .options =	oracle_options,
+  .options_count = nelem(oracle_options),
 };
 
 #ifdef DYNLOOKUP
diff --git a/src/src/lookups/pgsql.c b/src/src/lookups/pgsql.c
index 7071cb4ab..bef6c59e2 100644
--- a/src/src/lookups/pgsql.c
+++ b/src/src/lookups/pgsql.c
@@ -16,6 +16,9 @@ socket extension. */
 
 #include <libpq-fe.h>       /* The system header */
 
+
+static uschar * pgsql_servers = NULL;	/* List of servers and connect info */
+
 /* Structure and anchor for caching connections. */
 
 typedef struct pgsql_connection {
@@ -490,16 +493,26 @@ return g;
 }
 
 
+/******************************************************************************/
+/* Module API */
+
+static optionlist pgsql_options[] = {
+  { "pgsql_servers",	opt_stringptr,	{&pgsql_servers} }
+};
+
 static lookup_info _lookup_info = {
-  .name = US"pgsql",			/* lookup name */
-  .type = lookup_querystyle,		/* query-style lookup */
-  .open = pgsql_open,			/* open function */
-  .check = NULL,			/* no check function */
-  .find = pgsql_find,			/* find function */
-  .close = NULL,			/* no close function */
-  .tidy = pgsql_tidy,			/* tidy function */
-  .quote = pgsql_quote,			/* quoting function */
-  .version_report = pgsql_version_report           /* version reporting */
+  .name =	US"pgsql",			/* lookup name */
+  .type =	lookup_querystyle,		/* query-style lookup */
+  .open =	pgsql_open,			/* open function */
+  .check =	NULL,				/* no check function */
+  .find =	pgsql_find,			/* find function */
+  .close =	NULL,				/* no close function */
+  .tidy =	pgsql_tidy,			/* tidy function */
+  .quote =	pgsql_quote,			/* quoting function */
+  .version_report = pgsql_version_report,	/* version reporting */
+
+  .options =	pgsql_options,
+  .options_count = nelem(pgsql_options),
 };
 
 #ifdef DYNLOOKUP
diff --git a/src/src/lookups/redis.c b/src/src/lookups/redis.c
index 61c264a73..e88ded154 100644
--- a/src/src/lookups/redis.c
+++ b/src/src/lookups/redis.c
@@ -15,9 +15,7 @@
 
 #include <hiredis/hiredis.h>
 
-#ifndef nele
-# define nele(arr) (sizeof(arr) / sizeof(*arr))
-#endif
+static uschar * redis_servers = NULL;	/* List of servers and connect info */
 
 /* Structure and anchor for caching connections. */
 typedef struct redis_connection {
@@ -26,7 +24,7 @@ typedef struct redis_connection {
   redisContext    *handle;
 } redis_connection;
 
-static redis_connection *redis_connections = NULL;
+static redis_connection * redis_connections = NULL;
 
 
 static void *
@@ -210,7 +208,7 @@ if(sdata[1])
 
   Uskip_whitespace(&s);
 
-  for (i = 0; *s && i < nele(argv); i++)
+  for (i = 0; *s && i < nelem(argv); i++)
     {
     gstring * g;
 
@@ -438,17 +436,27 @@ return string_fmt_append(g, "Library version: REDIS: Compile: %d.%d.%d\n",
 
 
 
+/******************************************************************************/
+/* Module API */
+
+static optionlist redis_options[] = {
+  { "redis_servers",	opt_stringptr,	{&redis_servers} }
+};
+
 /* These are the lookup_info blocks for this driver */
 static lookup_info redis_lookup_info = {
-  .name = US"redis",			/* lookup name */
-  .type = lookup_querystyle,		/* query-style lookup */
-  .open = redis_open,			/* open function */
-  .check = NULL,			/* no check function */
-  .find = redis_find,			/* find function */
-  .close = NULL,			/* no close function */
-  .tidy = redis_tidy,			/* tidy function */
-  .quote = redis_quote,			/* quoting function */
-  .version_report = redis_version_report           /* version reporting */
+  .name =	US"redis",			/* lookup name */
+  .type =	lookup_querystyle,		/* query-style lookup */
+  .open =	redis_open,			/* open function */
+  .check =	NULL,				/* no check function */
+  .find =	redis_find,			/* find function */
+  .close =	NULL,				/* no close function */
+  .tidy =	redis_tidy,			/* tidy function */
+  .quote =	redis_quote,			/* quoting function */
+  .version_report = redis_version_report,	/*  version reporting */
+
+  .options =	redis_options,
+  .options_count = nelem(redis_options),
 };
 
 #ifdef DYNLOOKUP
diff --git a/src/src/lookups/sqlite.c b/src/src/lookups/sqlite.c
index eb23b8631..c91440e1e 100644
--- a/src/src/lookups/sqlite.c
+++ b/src/src/lookups/sqlite.c
@@ -12,6 +12,9 @@
 
 #include <sqlite3.h>
 
+static uschar * sqlite_dbfile = NULL;	/* Filename for database */
+static int	sqlite_lock_timeout = 5;/* Internal lock waiting timeout */
+
 
 /*************************************************
 *              Open entry point                  *
@@ -173,20 +176,31 @@ g = string_fmt_append(g,
 return g;
 }
 
+/******************************************************************************/
+/* Module API */
+
+static optionlist sqlite_options[] = {
+  { "sqlite_dbfile",            opt_stringptr,   {&sqlite_dbfile} },
+  { "sqlite_lock_timeout",      opt_int,         {&sqlite_lock_timeout} },
+};
+
 static lookup_info _lookup_info = {
-  .name = US"sqlite",			/* lookup name */
-  .type = lookup_absfilequery,		/* query-style lookup, starts with file name */
-  .open = sqlite_open,			/* open function */
-  .check = NULL,			/* no check function */
-  .find = sqlite_find,			/* find function */
-  .close = sqlite_close,		/* close function */
-  .tidy = NULL,				/* no tidy function */
-  .quote = sqlite_quote,		/* quoting function */
-  .version_report = sqlite_version_report          /* version reporting */
+  .name =	US"sqlite",			/* lookup name */
+  .type =	lookup_absfilequery,		/* query-style lookup, starts with file name */
+  .open =	sqlite_open,			/* open function */
+  .check =	NULL,				/* no check function */
+  .find =	sqlite_find,			/* find function */
+  .close =	sqlite_close,			/* close function */
+  .tidy =	NULL,				/* no tidy function */
+  .quote =	sqlite_quote,			/* quoting function */
+  .version_report = sqlite_version_report,	/* version reporting */
+
+  .options =	sqlite_options,
+  .options_count = nelem(sqlite_options),
 };
 
 #ifdef DYNLOOKUP
-#define sqlite_lookup_module_info _lookup_module_info
+# define sqlite_lookup_module_info _lookup_module_info
 #endif
 
 static lookup_info *_lookup_list[] = { &_lookup_info };
diff --git a/src/src/macros.h b/src/src/macros.h
index 0070ef7ed..f6b240322 100644
--- a/src/src/macros.h
+++ b/src/src/macros.h
@@ -707,7 +707,8 @@ can be easily tested as a group. That is the only use of opt_bool_last. */
 enum { opt_bit = 32, opt_bool_verify, opt_bool_set, opt_expand_bool,
   opt_bool_last,
   opt_rewrite, opt_timelist, opt_uid, opt_gid, opt_uidlist, opt_gidlist,
-  opt_expand_uid, opt_expand_gid, opt_func, opt_void, opt_module };
+  opt_expand_uid, opt_expand_gid, opt_func, opt_void,
+  opt_lookup_module, opt_misc_module };
 
 /* There's a high-ish bit which is used to flag duplicate options, kept
 for compatibility, which shouldn't be output. Also used for hidden options
